
package rankingimagenes;

import java.util.ArrayList;

/**
 *
 * @author Diego Vázquez Blanco
 */
public class Main {
    
    private static PresentacionesStateMachine PresentacionesStateMachine;
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        
        // Le da un estilo predefinido a la interfaz 
       try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Windows".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(PresentacionPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(PresentacionPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(PresentacionPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(PresentacionPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        
        // Crea la maquina de estado de las vistas
        PresentacionesStateMachine = new PresentacionesStateMachine();
    }
    
    /**
     * Llama a mostrarRanking en la máquina de estados de las vistas donde se 
     * procederá al cambio de interfaz.
     * @param array_seleccionadas Todos los datos de imágenes necesarios para
     * realizar la comparación y construir el ranking.
     * @param algoritmo El tipo de cálculo elegido para la comparación.
     */
    public static void mostrarRanking(ArrayList<ArrayList> array_seleccionadas, String algoritmo){
        PresentacionesStateMachine.mostrarRanking(array_seleccionadas, algoritmo);
    }
    
    /**
     * Vuelve de la vista en curso a la VistaPrincipal creando una nueva 
     * maquina de estados y destruyendo la vista en curso.
     */
    public static void volver(){
        PresentacionesStateMachine.close();
        PresentacionesStateMachine = new PresentacionesStateMachine();
    }
}
