/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rankingimagenes;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.HeadlessException;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardCopyOption;
import java.util.ArrayList;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

/**
 *
 * @author Diego Vazquez Blanco
 */
public class NegocioRanking {
    
    private PresentacionRanking mipresentacion;
    private DatosRanking misdatos;
    
    /**
     * Contructor de la clase
     * @param vista Referencia del objeto de la vista ranking para que el controlador creado tome el control. 
     * @param array_seleccionadas_rgb Lista con las imagenes en tipo BufferedImage seleccionadas.
     */
    public NegocioRanking(PresentacionRanking vista, ArrayList<ArrayList> array_seleccionadas, String algoritmo){
        this.mipresentacion = vista;
        this.misdatos = new DatosRanking(array_seleccionadas, algoritmo);
    }
    
    public final void mostrarRanking(){
        mipresentacion.getLabelSeleccionados().setVisible(false);
        mipresentacion.getLabelRanking().setVisible(false);
        mipresentacion.getScrollPaneSeleccionados().setVisible(false);
        mipresentacion.getScrollPaneRanking().setVisible(false);
        mipresentacion.getLabelCargando().setVisible(true);
        mipresentacion.getComponent(0).validate();
        
        ajustarParaRankingLabelsSeleccionados();
        calcularRanking(misdatos.getAlgoritmoCalculoRanking());
        mostrarImagenesSeleccionadas();
        mostrarSeparadorSeleccionadas();
        mostrarImagenesRanking();
        
        mipresentacion.getLabelSeleccionados().setVisible(true);
        mipresentacion.getLabelRanking().setVisible(true);
        mipresentacion.getScrollPaneSeleccionados().setVisible(true);
        mipresentacion.getScrollPaneRanking().setVisible(true);
        mipresentacion.getLabelCargando().setVisible(false);
        mipresentacion.getComponent(0).validate();
    }
    
    public void ajustarParaRankingLabelsSeleccionados(){
        
        for (int x = 0; x < misdatos.getListaLabelsSeleccionados().size(); x++){
            misdatos.getLabelListaSeleccionados(x).setBorder(BorderFactory.createLineBorder(Color.black, 2));
            misdatos.getLabelListaSeleccionados(x).setFocusable(false);
            misdatos.getLabelListaSeleccionados(x).removeMouseListener(misdatos.getLabelListaSeleccionados(x).getMouseListeners()[1]);
        }
    }
    
    public void calcularRanking(String algoritmo){
        int limite = 0;
        String aux = "";
        
        while(limite <= 0){
            try{
                aux=JOptionPane.showInputDialog("Escriba el numero máximo de imágenes más parecidas que\n"
                                                + "tendrá el ranking por cada imagen seleccionada. (Ej: 5)");
                if (aux == null){ // Si se presiona boton cancelar se para
                    algoritmo = "";
                    break;
                }
                else
                    limite = Integer.parseInt(aux);
            }catch(HeadlessException | NumberFormatException e){
                JOptionPane.showMessageDialog(mipresentacion, "No ha introducido el número correctamente.\n"
                                                    + "Por favor, asegúrese de no utilizar letras.");
            }
        }
        
        switch (algoritmo) {
            case "Resta Histogramas":
                JOptionPane.showMessageDialog(mipresentacion, "Se procederá a calcular el ranking de imágenes más parecidas según\nel algoritmo seleccionado. Esto podría tardar un tiempo.");
                algoritmoRestaHistogramas(limite);
                break;
            case "Resta Histogramas Umbral 20":
                JOptionPane.showMessageDialog(mipresentacion, "Se procederá a calcular el ranking de imágenes más parecidas según\nel algoritmo seleccionado. Esto podría tardar un tiempo.");
                algoritmoRestaHistogramasConUmbral(limite, 20);
                break;
            case "Resta Histogramas Umbral 50":
                JOptionPane.showMessageDialog(mipresentacion, "Se procederá a calcular el ranking de imágenes más parecidas según\nel algoritmo seleccionado. Esto podría tardar un tiempo.");
                algoritmoRestaHistogramasConUmbral(limite, 50);
                break;
            default:
                // Se ha cancelado la creacion del ranking y vuelve a la vistaPrincipal
                JOptionPane.showMessageDialog(mipresentacion, "Operación de comparación cancelada.");
                volver();
                break;
        }
    }
    
    public void algoritmoRestaHistogramas(int limite){
        ArrayList<int[][]> histogramas = new ArrayList<>();
        ArrayList<BufferedImage> lista_ranking_imagen = new ArrayList<>();
        ArrayList<String> lista_ranking_metadatos = new ArrayList<>();
        ArrayList<File> lista_ranking_ficheros = new ArrayList<>();
        int resta_histogramas[] = new int[256];
        int media[] = new int[misdatos.getListaSeleccionadasRGB().size()];
        ArrayList<Integer> lista_media = new ArrayList<>();
        int aux;
        
        for(int i = 0; i < misdatos.getListaSeleccionadasRGB().size(); i++){
            histogramas.add(Utils.getHistograma(misdatos.getImagenListaSeleccionadasRGB(i)));
        }
        
        for(int i = 0; i < misdatos.getListaSeleccionadasRGB().size(); i++){
            
            for(int j = 0; j < misdatos.getListaSeleccionadasRGB().size(); j++){
                media[j] = 0;
                for(int y = 0; y < 256; y++){
                    resta_histogramas[y] = Math.abs(histogramas.get(i)[4][y] - histogramas.get(j)[4][y]);
                    media[j] += resta_histogramas[y]/3;
                }
                lista_media.add(media[j]);
            }
            
            while(!lista_media.isEmpty()){
                aux = 2147483647;
                for(int j = 0; j < lista_media.size(); j++){
                    if (lista_media.get(j) < aux){
                        aux = lista_media.get(j);
                    }
                }

                for(int j = 0; j < lista_media.size(); j++){
                    if (lista_media.get(j) == aux){
                        lista_media.remove(j);
                        break;
                    }
                }
                
                for(int j = 0; j < misdatos.getListaSeleccionadasRGB().size(); j++){
                    if (media[j] == aux){
                        lista_ranking_imagen.add(misdatos.getImagenListaSeleccionadasRGB(j));
                        lista_ranking_metadatos.add(misdatos.getMetadatosListaSeleccionados(j));
                        lista_ranking_ficheros.add(misdatos.getFicheroListaSeleccionados(j));
                        break;
                    }
                }
                
                if (lista_ranking_imagen.size() == (limite+1))
                    break;
            }
            
            // Eliminamos la primera porque la mas parecida siempre es la misma imagen que se compara consigo misma
            lista_ranking_imagen.remove(0);
            lista_ranking_metadatos.remove(0);
            lista_ranking_ficheros.remove(0);
            
            cargarLabelsRanking(lista_ranking_imagen, lista_ranking_metadatos, lista_ranking_ficheros);
            
            lista_media.clear();
            lista_ranking_imagen.clear();
            lista_ranking_metadatos.clear();
            lista_ranking_ficheros.clear();
        }
    }
    
    public void algoritmoRestaHistogramasConUmbral(int limite, int umbral){
        ArrayList<int[][]> histogramas = new ArrayList<>();
        ArrayList<BufferedImage> lista_ranking_imagen = new ArrayList<>();
        ArrayList<String> lista_ranking_metadatos = new ArrayList<>();
        ArrayList<File> lista_ranking_ficheros = new ArrayList<>();
        int resta_histogramas[] = new int[256];
        int media[] = new int[misdatos.getListaSeleccionadasRGB().size()];
        ArrayList<Integer> lista_media = new ArrayList<>();
        int aux;
        
        for(int i = 0; i < misdatos.getListaSeleccionadasRGB().size(); i++){
            histogramas.add(Utils.getHistograma(misdatos.getImagenListaSeleccionadasRGB(i)));
        }
        
        for(int i = 0; i < misdatos.getListaSeleccionadasRGB().size(); i++){
            
            for(int j = 0; j < misdatos.getListaSeleccionadasRGB().size(); j++){
                media[j] = 0;
                for(int y = (0+umbral); y < (256-umbral); y++){
                    resta_histogramas[y] = Math.abs(histogramas.get(i)[4][y] - histogramas.get(j)[4][y]);
                    media[j] += resta_histogramas[y]/3;
                }
                lista_media.add(media[j]);
            }
            
            while(!lista_media.isEmpty()){
                aux = 2147483647;
                for(int j = 0; j < lista_media.size(); j++){
                    if (lista_media.get(j) < aux){
                        aux = lista_media.get(j);
                    }
                }

                for(int j = 0; j < lista_media.size(); j++){
                    if (lista_media.get(j) == aux){
                        lista_media.remove(j);
                        break;
                    }
                }
                
                for(int j = 0; j < misdatos.getListaSeleccionadasRGB().size(); j++){
                    if (media[j] == aux){
                        lista_ranking_imagen.add(misdatos.getImagenListaSeleccionadasRGB(j));
                        lista_ranking_metadatos.add(misdatos.getMetadatosListaSeleccionados(j));
                        lista_ranking_ficheros.add(misdatos.getFicheroListaSeleccionados(j));
                        break;
                    }
                }
                
                if (lista_ranking_imagen.size() == (limite+1))
                    break;
            }
            
            // Eliminamos la primera porque la mas parecida siempre es la misma imagen que se compara consigo misma
            lista_ranking_imagen.remove(0);
            lista_ranking_metadatos.remove(0);
            lista_ranking_ficheros.remove(0);
            
            cargarLabelsRanking(lista_ranking_imagen, lista_ranking_metadatos, lista_ranking_ficheros);
            
            lista_media.clear();
            lista_ranking_imagen.clear();
            lista_ranking_metadatos.clear();
            lista_ranking_ficheros.clear();
        }
    }
    
    public void cargarLabelsRanking(ArrayList<BufferedImage> lista_ranking_imagen, ArrayList<String> lista_ranking_metadatos, ArrayList<File> lista_ranking_ficheros){
        int ancho;      // pixeles de anchura de la imagen reducida
        int alto;       // pixeles de altura de la imagen reducida
        JLabel jlabel;
        MouseListener mouseListener;
        
        misdatos.addArrayListasLabelsRanking(new ArrayList<>());
        misdatos.addArrayListasFicherosRanking(new ArrayList<>());
        
        for (int x = 0; x < lista_ranking_imagen.size(); x++){

            // Calcula el alto y ancho de la imagen reducida de forma que mantenga la relacion de aspecto
            if (lista_ranking_imagen.get(x).getHeight() > lista_ranking_imagen.get(x).getWidth()){
                alto = 200;
                ancho = lista_ranking_imagen.get(x).getWidth()* alto / lista_ranking_imagen.get(x).getHeight();
            }
            else {
                ancho = 200;
                alto = lista_ranking_imagen.get(x).getHeight() * ancho / lista_ranking_imagen.get(x).getWidth();
            }

            // Incorpora la imagen a un label y este a su vez a una lista de labels
            Icon icono = new ImageIcon(lista_ranking_imagen.get(x).getScaledInstance(ancho, alto, Image.SCALE_DEFAULT));

            // Creacion de un label, configuracion y añadido al array de labels
            jlabel = new JLabel(icono);
            jlabel.setSize(200, 200);
            jlabel.setFocusable(false);
            jlabel.setToolTipText(lista_ranking_metadatos.get(x));
            mouseListener = new MouseListener() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    JLabel label = (JLabel) e.getComponent();
                    if (label.isFocusable()){
                        comprobarDeseleccionRanking(label);
                    }
                    else {
                        comprobarSeleccionRanking(label);
                    }
                }
                @Override
                public void mousePressed(MouseEvent e) {
                }
                @Override
                public void mouseReleased(MouseEvent e) {
                }
                @Override
                public void mouseEntered(MouseEvent e) {
                }
                @Override
                public void mouseExited(MouseEvent e) {
                }
            };
            jlabel.addMouseListener(mouseListener);
            
            misdatos.getListaArrayListasLabelsRanking(misdatos.getArrayListasLabelsRanking().size() - 1).add(jlabel);
            misdatos.getListaArrayListasFicherosRanking(misdatos.getArrayListasFicherosRanking().size() - 1).add(lista_ranking_ficheros.get(x));
        }
    }
    
    public void mostrarImagenesSeleccionadas(){
        int fila = 0;   // contador de filas al ir añadiendo imagenes al panel
        
        // Coloca cada imagen donde debe (Contenedor cada imagen: 200x200, Margen Horizontal: 10, Margen Vertical: 50)
        for (int x = 0; x < misdatos.getListaLabelsSeleccionados().size(); x++){
            misdatos.getLabelListaSeleccionados(x).setLocation(10, 50 + 250*fila);
            mipresentacion.getPanelSeleccionados().add(misdatos.getLabelListaSeleccionados(x));
            fila++;
        }
        
        // Dimensiona el Panel Principal para contener todas las imagenes del directorio
        Dimension d = new Dimension(10 + 200 + 10, // 10 margen + 200 imagen + 10 margen
                                    50 + (200+50) * misdatos.getListaLabelsSeleccionados().size()); // 50 de margen vertical
        mipresentacion.getPanelSeleccionados().setPreferredSize(d);
        mipresentacion.getPanelSeleccionados().setSize(d);
        
        mipresentacion.getPanelSeleccionados().repaint();
    }
    
    public void mostrarSeparadorSeleccionadas(){
        int fila = 0;   // contador de filas al ir añadiendo labels al panel
        JLabel label;
        JLabel label2;
        
        // Coloca cada "-->" donde debe (Contenedor cada label: 20x10, Margen Horizontal: 10, Margen Vertical: 145)
        for (int x = 0; x < misdatos.getListaLabelsSeleccionados().size(); x++){
            label = new JLabel();
            label.setSize(20, 10);
            label.setText("-->");
            label.setLocation(10 + 200 + 10, 50 + 95 + (10+95+50+95)*fila);
            mipresentacion.getPanelSeleccionados().add(label);
            fila++;
        }
        
        fila = 0;
        // Coloca cada separador donde debe (Contenedor cada label: 260x2, Margen Horizontal: 0)
        for (int x = 0; x < misdatos.getListaLabelsSeleccionados().size() - 1; x++){
            label2 = new JLabel();
            label2.setSize(260, 2);
            label2.setText("------------------------------------------------------------------------------------------------");
            label2.setLocation(0, 50 + 200 + 24 + (26+200+24)*fila);
            mipresentacion.getPanelSeleccionados().add(label2);
            fila++;
        }
        
        // Dimensiona el Panel Principal para contener los separadores
        Dimension d = new Dimension(10 + 200 + 10 + 20, // 10 margen + 200 imagen + 10 margen + 20 (-->)
                                    50 + (200+50) * misdatos.getListaLabelsSeleccionados().size()); // 30 de margen vertical
        mipresentacion.getPanelSeleccionados().setPreferredSize(d);
        mipresentacion.getPanelSeleccionados().setSize(d);
        
        mipresentacion.getPanelSeleccionados().repaint();
    }
    
    public void mostrarImagenesRanking(){
        int cont = 0;   // lleva el contador para no pasar del numero de columnas que caben
        int max = 0;    // maximo tamano de entre todas las listas de labels ranking
        JLabel label;
        
        // Coloca cada imagen donde debe (ContenedorCadaImagen: 200x200, Margen: 10)
        for (int y = 0; y < misdatos.getArrayListasLabelsRanking().size(); y++){
            for (int x = 0; x < misdatos.getListaArrayListasLabelsRanking(y).size(); x++){
                
                // Mete la imagen
                misdatos.getListaArrayListasLabelsRanking(y).get(x).setLocation(10 + 210*cont, 50 + 250*y);
                mipresentacion.getPanelRanking().add(misdatos.getListaArrayListasLabelsRanking(y).get(x));
                
                // Mete el separador debajo de la imagen si no es la ultima fila
                if (y < misdatos.getArrayListasLabelsRanking().size() - 1)
                {
                    label = new JLabel();
                    label.setSize(225, 2);
                    label.setText("---------------------------------------------------------------------------------------------------------");
                    label.setLocation(210*cont, 50 + 200 + 24 + (26+200+24)*y);
                    mipresentacion.getPanelRanking().add(label);
                }
                
                cont++;
            }
            cont=0;
            if (misdatos.getListaArrayListasLabelsRanking(y).size() > max)
                max = misdatos.getListaArrayListasLabelsRanking(y).size();
        }
        // Dimensiona el Panel Principal para contener todas las imagenes del directorio
            Dimension d = new Dimension(10 + 210 * max,
                                        50 + 250 * misdatos.getListaLabelsSeleccionados().size());
            mipresentacion.getPanelRanking().setPreferredSize(d);
            mipresentacion.getPanelRanking().setSize(d);
            
            mipresentacion.getPanelRanking().repaint();
    }
    
    public void comprobarSeleccionRanking(JLabel label){
        for (int x = 0; x < misdatos.getArrayListasLabelsRanking().size(); x++){
            for (int y = 0; y < misdatos.getListaArrayListasLabelsRanking(x).size(); y++){
                if (misdatos.getListaArrayListasLabelsRanking(x).get(y).getToolTipText().equals(label.getToolTipText())
                        && !misdatos.getListaArrayListasFicherosRanking(x).get(y).getName().equals("Imagen-Eliminada.png")){
                    misdatos.getListaArrayListasLabelsRanking(x).get(y).setFocusable(true);
                    misdatos.getListaArrayListasLabelsRanking(x).get(y).setBorder(BorderFactory.createLineBorder(Color.red, 5));
                }
            }
        }
    }
    public void comprobarDeseleccionRanking(JLabel label){
        for (int x = 0; x < misdatos.getArrayListasLabelsRanking().size(); x++){
            for (int y = 0; y < misdatos.getListaArrayListasLabelsRanking(x).size(); y++){
                if (misdatos.getListaArrayListasLabelsRanking(x).get(y).getToolTipText().equals(label.getToolTipText())){
                    misdatos.getListaArrayListasLabelsRanking(x).get(y).setFocusable(false);
                    misdatos.getListaArrayListasLabelsRanking(x).get(y).setBorder(BorderFactory.createLineBorder(Color.gray));
                }
            }
        }
    }
    
    public void eliminarSeleccionadasRanking(){
        boolean hay_seleccionadas = false;
        int opcion = JOptionPane.NO_OPTION;
        File carpetaEliminadas = new File("./Imagenes_Eliminadas");
        
        mipresentacion.getLabelSeleccionados().setVisible(false);
        mipresentacion.getLabelRanking().setVisible(false);
        mipresentacion.getScrollPaneSeleccionados().setVisible(false);
        mipresentacion.getScrollPaneRanking().setVisible(false);
        mipresentacion.getLabelCargando().setVisible(true);
        mipresentacion.getComponent(0).validate();
        
        for (int x = 0; x < misdatos.getArrayListasLabelsRanking().size(); x++){
            for (int y = 0; y < misdatos.getListaArrayListasLabelsRanking(x).size(); y++){
                if (misdatos.getListaArrayListasLabelsRanking(x).get(y).isFocusable()){
                    hay_seleccionadas = true;
                    break;
                }
            }
        }
        
        if (!hay_seleccionadas)
            JOptionPane.showMessageDialog(mipresentacion, "No se ha seleccionado ninguna imagen para eliminar.");
        else
            opcion = JOptionPane.showConfirmDialog(mipresentacion, "¿Seguro que desea eliminar las imágenes seleccionadas?", "Confirmación", JOptionPane.YES_NO_OPTION);
        
        if(opcion == JOptionPane.YES_OPTION){
            
            if (!carpetaEliminadas.exists())
                            carpetaEliminadas.mkdir();
            
            for (int x = 0; x < misdatos.getArrayListasLabelsRanking().size(); x++){
                for (int y = 0; y < misdatos.getListaArrayListasLabelsRanking(x).size(); y++){
                    if (misdatos.getListaArrayListasLabelsRanking(x).get(y).isFocusable()){
                        try {
                            Files.move(Paths.get(misdatos.getListaArrayListasFicherosRanking(x).get(y).getAbsolutePath()), 
                                        Paths.get(new File(carpetaEliminadas, misdatos.getListaArrayListasFicherosRanking(x).get(y).getName()).getAbsolutePath()), 
                                        StandardCopyOption.REPLACE_EXISTING);
                        } catch (Exception e) {}
                        misdatos.getListaArrayListasFicherosRanking(x).remove(y);
                        misdatos.getListaArrayListasFicherosRanking(x).add(y, new File("/rankingimagenes/Imagen-Eliminada.png"));
                        misdatos.getListaArrayListasLabelsRanking(x).get(y).setIcon(new ImageIcon(getClass().getResource("/rankingimagenes/Imagen-Eliminada.png")));
                        misdatos.getListaArrayListasLabelsRanking(x).get(y).setFocusable(false);
                    }
                }
            }
        }
        
        mostrarImagenesRanking();
        
        mipresentacion.getLabelSeleccionados().setVisible(true);
        mipresentacion.getLabelRanking().setVisible(true);
        mipresentacion.getScrollPaneSeleccionados().setVisible(true);
        mipresentacion.getScrollPaneRanking().setVisible(true);
        mipresentacion.getLabelCargando().setVisible(false);
        mipresentacion.getComponent(0).validate();
    }
    
    public void showInfo(){
        JOptionPane.showMessageDialog(mipresentacion, "Al eliminar imágenes, éstas se moverán a la carpeta \"Imagenes_Eliminadas\"\n"
                                            + "localizada en el mismo lugar que el ejecutable de la aplicación.\n\n"
                                            + "Para salir de la aplicación, presionar la [X] de la esquina superior\nderecha de la ventana.\n\n"
                                            + "Para regresar a la ventana principal, presionar el botón [Volver].\n");
    }
    
    public void volver(){
        Main.volver();
    }
}
